#ifndef POINTLIGHT_HXX
#define POINTLIGHT_HXX

#include "Light.hxx"

class PointLight : public Light
{
public:
  PointLight(Scene* scene, const Vec3f& pos, const Vec3f& intensity);
  virtual ~PointLight();

  virtual bool Illuminate(Ray& ray, Vec3f& intensity);

  const Vec3f& position() const;
  const Vec3f& intensity() const;

  virtual bool IsArea();

private:
  PointLight();
 
  // origin
  Vec3f m_pos;
  // emission ( red, green, blue )
  Vec3f m_intensity;
};
#endif
