#ifndef SPHERE_HXX
#define SPHERE_HXX

#include "Primitive.hxx"


class Sphere : public Primitive
{
public:
  Sphere(const Vec3f& center, float radius, Shader* shader);
  virtual ~Sphere();

  virtual bool Intersect(Ray& ray);  
  virtual Vec3f GetNormal(Ray& ray);
  virtual Box CalcBounds();
  virtual bool InVoxel(const Box& box);
private:
  Vec3f m_center;
  float m_radius;
};
#endif
